//  Bezrodnykh I.P.    Visual C++ 
////////////////////////////////////////////////////////////////
//   
bool CreateHous(char* pFileName,char* pUpFileName, C3dShape* pShape, C3dScene *pScene)
{

//===================================================================
	// Create a 2-unit cube	with separate faces
	double s = 2;


   
    D3DVECTOR vlist[] = {
   
        {-1.0, -1.0,  -1.0},
        {-1.0,  1.0,  -1.0},
        {-1.0,  1.0,   1.0},
        {-1.0, -1.0,   1.0}, // Left

        { 1.0, -1.0,  -1.0},
        { 1.0,  1.0,  -1.0},
        { 1.0,  1.0,   1.0},
        { 1.0, -1.0,   1.0}, // Right

        {-1.0, -1.0,  -1.0},
        {-1.0,  1.0,  -1.0},
        { 1.0,  1.0,  -1.0},
        { 1.0, -1.0,  -1.0}, // Front

        {-1.0, -1.0,   1.0},
        {-1.0,  1.0,   1.0},
        { 1.0,  1.0,   1.0},
        { 1.0, -1.0,   1.0},  // Back

        {-1.0,  1.0,  -1.0},
        { 1.0,  1.0,  -1.0},
        { 1.0,  1.0,   1.0},
        {-1.0,  1.0,   1.0}, // Top
	
		
	{-1.0, -1.0,  -1.0},
        { 1.0, -1.0,  -1.0},
        { 1.0, -1.0,   1.0},
        {-1.0, -1.0,   1.0} // Bottom



    };

	 
    int iVectors = sizeof(vlist) / sizeof(D3DVECTOR);
    int iFaces[] =  {   4, 3,  2,  1,  0,
                        4, 5,  6,  7,  4,
                        4, 9,  10, 11, 8,
			4, 15, 14, 13, 12,				
			4, 19, 18, 17, 16,
			4, 20, 23, 22, 21,
                    0}; 

    pShape->Create(vlist, iVectors, iFaces);
  
	for (int i = 0; i < 4; i++) {

		// Load texture map
        C3dTexture* pTex = new C3dTexture;
	 	pScene->m_ImgList.Append(pTex);
		if (pTex->Load(pFileName)) {

			// Attach texture to face
                        //    
			pShape->SetFaceTexture(i, pTex);

			// Get face normal
                        //    
			C3dVector vn = pShape->GetFaceNormal(i);

			// Reverse face normal so it represents the wrap
			// direction
                        //    ,   
                        //   
		   vn = -vn;

			// Compute an arbitrary up vector
                        //    
			C3dVector vu = vn.GenerateUp();

			// Create a wrap oriented to this face
                        //  ,    
			C3dWrap wrap;
			wrap.Create(D3DRMWRAP_FLAT,
						NULL,
  						-s/2, -s/2, -s/2, //  
						vn.x, vn.y, vn.z, // 
						vu.x, vu.y, vu.z, // 
						0, pTex->GetHeight()-1,	//   
						1.0/s, -1.0/s);	 //   ( )

			// Apply wrap to face
                        //   
			wrap.Apply(pShape, i);
			
		}
	}

	for ( i = 4; i < 6; i++) {

		// Load texture map
        C3dTexture* pTex = new C3dTexture;
	 	pScene->m_ImgList.Append(pTex);
		if (pTex->Load(pUpFileName)) {

			// Attach texture to face
                        //    
			pShape->SetFaceTexture(i, pTex);

			// Get face normal
                        //    
			C3dVector vn = pShape->GetFaceNormal(i);

			// Reverse face normal so it represents the wrap
			// direction
                        //    ,   
                        //   
		   vn = -vn;

			// Compute an arbitrary up vector
                        //    
			C3dVector vu = vn.GenerateUp();

			// Create a wrap oriented to this face
                        //  ,    
			C3dWrap wrap;
			wrap.Create(D3DRMWRAP_FLAT,
						NULL,
  						-s/2, -s/2, -s/2, //  
						vn.x, vn.y, vn.z, // 
						vu.x, vu.y, vu.z, // 
						0, pTex->GetHeight()-1,	//   
						1.0/s, -1.0/s);	 //   ( )

			// Apply wrap to face
                        //   
			wrap.Apply(pShape, i);
			
		}
	}


	pShape->SetName("Hous01");
	pScene->AddChild(pShape);
    pScene->m_ShapeList.Append(pShape);

	return true;
}

////////////////////////////////////////////////////////////////
//    
bool CreateHous(int IDB_BMP,int IDB_UPBMP,C3dShape* pShape, C3dScene *pScene)
{

//===================================================================
	// Create a 2-unit cube	with separate faces
	double s = 2;


   
   D3DVECTOR vlist[] = {
   
        {-1.0, -1.0,  -1.0},
        {-1.0,  1.0,  -1.0},
        {-1.0,  1.0,   1.0},
        {-1.0, -1.0,   1.0}, // Left

        { 1.0, -1.0,  -1.0},
        { 1.0,  1.0,  -1.0},
        { 1.0,  1.0,   1.0},
        { 1.0, -1.0,   1.0}, // Right

        {-1.0, -1.0,  -1.0},
        {-1.0,  1.0,  -1.0},
        { 1.0,  1.0,  -1.0},
        { 1.0, -1.0,  -1.0}, // Front

        {-1.0, -1.0,   1.0},
        {-1.0,  1.0,   1.0},
        { 1.0,  1.0,   1.0},
        { 1.0, -1.0,   1.0},  // Back

        {-1.0,  1.0,  -1.0},
        { 1.0,  1.0,  -1.0},
        { 1.0,  1.0,   1.0},
        {-1.0,  1.0,   1.0}, // Top
	
		
	{-1.0, -1.0,  -1.0},
        { 1.0, -1.0,  -1.0},
        { 1.0, -1.0,   1.0},
        {-1.0, -1.0,   1.0} // Bottom



    };

	 
    int iVectors = sizeof(vlist) / sizeof(D3DVECTOR);
    int iFaces[] =  {   4, 3,  2,  1,  0,
                        4, 5,  6,  7,  4,
                        4, 9,  10, 11, 8,
			4, 15, 14, 13, 12,				
			4, 19, 18, 17, 16,
			4, 20, 23, 22, 21,
                    0}; 


    pShape->Create(vlist, iVectors, iFaces);
     
    int i;
	for ( i = 0; i < 4; i++) {

		// Load texture map
                C3dTexture* pTex = new C3dTexture;
	 	pScene->m_ImgList.Append(pTex);
		if (pTex->Load(IDB_BMP)) {

			// Attach texture to face
                        //    
			pShape->SetFaceTexture(i, pTex);

			// Get face normal
                        //    
			C3dVector vn = pShape->GetFaceNormal(i);

			// Reverse face normal so it represents the wrap
			// direction
                        //    ,   
                        //   
		       vn = -vn;

			// Compute an arbitrary up vector
                        //    
			C3dVector vu = vn.GenerateUp();

			// Create a wrap oriented to this face
                        //  ,    
			C3dWrap wrap;
			wrap.Create(D3DRMWRAP_FLAT,
						NULL,
  						-s/2, -s/2, -s/2, //  
						vn.x, vn.y, vn.z, // 
						vu.x, vu.y, vu.z, // 
						0, pTex->GetHeight()-1,	//   
						1.0/s, -1.0/s);	 //   ( )

			// Apply wrap to face
                        //   
			wrap.Apply(pShape, i);
			
		}
	}

	for ( i = 4; i < 6; i++) {

		// Load texture map
                C3dTexture* pTex = new C3dTexture;
	 	pScene->m_ImgList.Append(pTex);
		if (pTex->Load(IDB_UPBMP)) {

			// Attach texture to face
                        //    
			pShape->SetFaceTexture(i, pTex);

			// Get face normal
                        //    
			C3dVector vn = pShape->GetFaceNormal(i);

			// Reverse face normal so it represents the wrap
			// direction
                        //    ,   
                        //   
		        vn = -vn;

			// Compute an arbitrary up vector
                        //    
			C3dVector vu = vn.GenerateUp();

			// Create a wrap oriented to this face
                        //  ,    
			C3dWrap wrap;
			wrap.Create(D3DRMWRAP_FLAT,
						NULL,
  						-s/2, -s/2, -s/2, //  
						vn.x, vn.y, vn.z, // 
						vu.x, vu.y, vu.z, // 
						0, pTex->GetHeight()-1,	//   
						1.0/s, -1.0/s);	 //   ( )

			// Apply wrap to face
                        //   
			wrap.Apply(pShape, i);
			
		}
	}


	pShape->SetName("Hous01");
	pScene->AddChild(pShape);
    pScene->m_ShapeList.Append(pShape);

	return true;
}


	  	  