//     
#define KEY_DOWN(vk_code) ((GetAsyncKeyState(vk_code) & 0x8000) ? 1 : 0)
#define KEY_UP(vk_code) ((GetAsyncKeyState(vk_code) & 0x8000) ? 0 : 1)


  

class CCamera: public C3dCamera
{

public:
        CCamera();   
	void SetCameraPosition(D3DVECTOR& p);
	void SetCameraDirection(D3DVECTOR& d);
	void SetCameraDirection(D3DVECTOR& d, D3DVECTOR& u);
	void SetCameraField(double f);
        void SetCamera();
        void SetCamera(D3DVECTOR& p,D3DVECTOR& d, D3DVECTOR& u);
	C3dVector m_vCamPos;		// camera position
	C3dVector m_vCamDir;		// camera direction
	C3dVector m_vCamUp;			// camera up vector
	double m_dCamField;			// camera field of view
        C3dScene* pCam; 
        void InputKey();
        double dx,dy,dz;
        double ax,ay,az;
        void Init(C3dScene* p);
        C3dShape g ; 

        ~CCamera(); 

   double    dCamera;
   bool      Active;
    


};




 

CCamera::CCamera()
: m_vCamPos(0, 0, -10), m_vCamDir(0, 0, 1), m_vCamUp(0, 1, 0),
m_dCamField(0.5)
{
      pCam=NULL;
      dx=dy=dz=0;
      ax=ay=az=0; 


}

CCamera::~CCamera()
{
 
}


void CCamera::Init(C3dScene* p) 
{
      pCam=p;
      if(pCam) SetCamera();

      g.CreateCuboid(0.01, 0.01, 0.01);
      g.SetPosition(m_vCamPos);
      g.SetDirection(m_vCamDir,m_vCamUp);
      g.SetColor(1, 0, 0);
	  

}


void CCamera::SetCameraPosition(D3DVECTOR& p)
{
	if(pCam) pCam->SetCameraPosition(p);
}

void CCamera::SetCameraDirection(D3DVECTOR& d)
{

      if(pCam)   pCam->SetCameraDirection( d);

}

void CCamera::SetCameraDirection(D3DVECTOR& d, D3DVECTOR& u)
{
	if(pCam) pCam->SetCameraDirection(d,u);
}

void CCamera::SetCameraField(double f)
{
	if(pCam) pCam->SetCameraField( f);
}
	
	
void   CCamera::SetCamera()
{
     if(pCam)
      {
       pCam->SetCameraPosition(m_vCamPos);
       pCam->SetCameraDirection( m_vCamDir,m_vCamUp);
      } 

}


void   CCamera::SetCamera(D3DVECTOR& p,D3DVECTOR& d,D3DVECTOR& u)
{
      
       m_vCamPos=p;
       m_vCamDir=d;
       m_vCamUp =u;
      if(pCam) SetCamera();
       

}


void CCamera::InputKey()
{
    
 
     if(KEY_DOWN(65))         dx -= 1;  //a  
     if(KEY_DOWN(68) )        dx += 1;  //d

     if(KEY_DOWN(107))        dy += 1;  //+ 
     if(KEY_DOWN(109) )       dy -= 1;  //-

     if(KEY_DOWN(83))         dz -= 1;  // s 
     if(KEY_DOWN(87) )        dz += 1;  // w
   

   //  if(KEY_DOWN(VK_DOWN))    ax += 1;  //   
   //  if(KEY_DOWN(VK_UP) )     ax -= 1; 
     if(KEY_DOWN(VK_LEFT))    ay -= 1;   
     if(KEY_DOWN(VK_RIGHT) )  ay += 1; 
     if(KEY_DOWN(100))        az -= 1;  // 4 
     if(KEY_DOWN(102) )       az += 1;  // 6
     if(KEY_DOWN(VK_SPACE) ) 
	 {
	  m_vCamPos=C3dVector(-1000,800,0);
      m_vCamDir=C3dVector(1,0,0);
      m_vCamUp =C3dVector(0,1,0);
	 }   


//    
     C3dMatrix mt;
     mt.Translate( dx,dy,dz);
     mt.Rotate(ax,ay,az );
     g.AddTransform(mt, D3DRMCOMBINE_BEFORE);

    ax=ax*0.9;  ay = ay*0.9;  az=az*0.9;
    dx=dx*0.9;  dy = dy*0.9;  dz=dz*0.9;
 




//   cuboida
     g.GetPosition(m_vCamPos);
     g.GetDirection(m_vCamDir,m_vCamUp);

   

//  
    if(pCam) SetCamera();
  

}